import 'dart:io';
import 'dart:typed_data';

import 'package:flutter_xtransport/flutter_xtransport.dart';

class WtEx2 implements Packet {
  @override
  Uint8List pack() {
    return Uint8List.fromList([1, 2, 3, 4, 5]);
  }
}

void main(List<String> arguments) async {
  Uint8List cert = File('cert/client.pem').readAsBytesSync();
  Uint8List key = File('cert/client.key').readAsBytesSync();
  Uint8List ca = File('cert/ca.pem').readAsBytesSync();
  SecurityContext context = SecurityContext(withTrustedRoots: true);
  context.useCertificateChainBytes(cert);
  context.usePrivateKeyBytes(key);
  context.setTrustedCertificatesBytes(ca);
  var cli = XTransportTcpClient(
    "127.0.0.1",
    8883,
    authority: "xxx.apple.com",
    onBadCertificate: (_) => true,
    securityContext: context,
  );
  cli.onMessage((msg) {
    print(msg.toJson());
    // throw ("haha");
    // cli.close();
    
  });
  cli.onClose(() {
    print("closed");
    Future.delayed(const Duration(seconds: 1)).then((_) => cli.connect());
    // cli.connect();
  });
  cli.onError((err) {
    print("Error! ${err.errMsg}");
  });
  cli.onConnect(() {
    print("connected");
    print("ready");
    cli.send(WtEx2());
  });

  cli.connect();
  cli.connect();
  await Future.delayed(const Duration(seconds: 10));
}
