import 'dart:io';
import 'dart:typed_data';

import 'package:flutter_xtransport/src/jsons.dart';

// import 'dart:ui';

class XTransportError {
  String errMsg = "";
  XTransportError.from(dynamic msg) {
    errMsg = msg.toString();
  }
  XTransportError.fromString(String msg) {
    errMsg = msg;
  }
}

class XTransportMessage {}

abstract class Packet {
  Uint8List pack();
}

abstract class XTransportClient {
  SecurityContext? securityContext;
  String? authority;
  bool Function(X509Certificate)? onBadCertificate;
  // void send<T extends Packet>(T obj);
  void send(Packet obj);
  void close();
  void onClose(void Function() fn);
  void onConnect(void Function() fn);
  void onError(void Function(XTransportError err) fn);
  void onMessage(void Function(XMessage msg) fn);
}

abstract class Transport {
  XTransportClient dial(String addr);
}

enum ConnectStatus { disconnect, connecting, connected, paused }
